

renoise.tool():add_menu_entry {
  name = "Pattern Sequencer:Keep Selected Pattern Looping",
  selected = function() return options.loop_enabled.value end,
  invoke = function()
    --toggle bool 
    options.loop_enabled.value = not options.loop_enabled.value
    --pass bool to notif. fn
    add_or_remove_notifier(options.loop_enabled.value)
    end
}

-----------------------------------
--preferences
-----------------------------------
options = renoise.Document.create {
  loop_enabled = false,
}
renoise.tool().preferences = options
--options files need to be accessed via 'options.variable.value'
--i.e: 
--local auto_max_boolean = options.auto_max_enabled.value
-----------------------------------

----------------------------------------
function keep_selected_pattern_looping() 
---------------------------------------- 
  local song = renoise.song()
  --set loop to selected seq
  if song.transport.loop_sequence_range[1] ~= song.selected_sequence_index then
    song.transport.loop_sequence_range = {song.selected_sequence_index,song.selected_sequence_index}
  end
end

---------------------------------------
function add_or_remove_notifier(enabled)
----------------------------------------
  if enabled == true then
    --selected_sequence_index_observable
    if renoise.song().selected_sequence_index_observable:has_notifier(keep_selected_pattern_looping) == false then
      renoise.song().selected_sequence_index_observable:add_notifier(keep_selected_pattern_looping)
      return
    end
  end  
  if renoise.song().selected_sequence_index_observable:has_notifier(keep_selected_pattern_looping) == true then
    renoise.song().selected_sequence_index_observable:remove_notifier(keep_selected_pattern_looping)
  end
end 

--set up on new song --get enabled bool from options
renoise.tool().app_new_document_observable:add_notifier(function()add_or_remove_notifier(options.loop_enabled.value)end)
  
  
  

